import { Button, Descriptions, Badge, Popconfirm, Row, Col, Form, Input, Select, Table } from 'antd';
import React from 'react';
import { initFilter, extendRule, extendInclude, setDataFieldValue, showApprove, guid, initQueryFilter, ShowDateTime, ShowPrintClose, showFiles } from '../../../utils/common';
import ReactToPrint from 'react-to-print';
import { ExportToExcel } from '@woowalker/feui'
import XLSX from 'xlsx';
import { connect } from 'dva';
import moment from 'moment';
import { message } from 'antd/lib/index';
import styles from '../../../components/CustomPages/HI/StepForm.css';
import config from '../../../config.js';
import FormPage from '../../FormPage'
class TL014ShowPrint extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            data: null,
            btndisplay: 'none',
            isCheck: false, //是否待办 审批
        }
    }

    componentDidMount() {
        if (this.props.data?.id)
            this.loadData(this.props.data?.id);
    }

    componentWillReceiveProps(NextProps) {
        if (NextProps.data?.id && this.props.data?.id != NextProps.data?.id) {
            this.loadData(NextProps.data?.id);
        }
    }

    onTableBtnExport() {
        let TableWrap = document.getElementById('table1');
        let Table = TableWrap.getElementsByTagName('table1')[0];
        const wb = XLSX.utils.table_to_book(Table);
        XLSX.writeFile(wb, this.props.record.Nav_Department.NAME + '.xlsx')

    }

    onClickApprove = (appVisible) => {
        const newtmpData = {
            data: { id: this.props.data.id, isShow: true, key: guid(), param: this.props.data.param, appVisible: appVisible, BtnAgreeDisplay: 'none' },
            formCode: 'PF123',
        }
        this.setState({
            tmpData: newtmpData,
        });
    }
    loadData = (id) => {
        var isCheck = (this.props.data.tableKey != undefined && this.props.data.tableKey == '1') ? true : false
        var orgId = this.props.login ? this.props.login.OrgId : '';
        let json = initFilter(orgId);
        extendRule(json, 'ID', 1, id);
        extendInclude(json, 'Nav_ListBackRequire.Nav_Require')
        extendInclude(json, 'Nav_Files.Nav_ImgFile.Nav_File')
        extendInclude(json, 'Nav_ListDetail.Nav_ListDetailUser.Nav_User')
        json.IgnoreDataRule = true
        this.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'TL/Back/Get',
            onComplete: (ret) => {
                if (ret) {
                    if (ret.Nav_ListDetail != null && ret.Nav_ListDetail.length > 0) {
                        ret.Nav_ListDetail.sort(function (a, b) {
                            return b.NUM > a.NUM ? -1 : 1
                        })
                    }

                    if (isCheck) {
                        isCheck = ret.STATUS == 10 ? true : false
                    }
                    this.setState({
                        data: ret,
                        isCheck: isCheck
                    })
                }
            }
        });
    }

    //确认
    sureCheck = () => {
        let json = initFilter(this.props.login.OrgId, this.props.data.id, null, null, null, this.props.data.TaskID);
        this.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'TL/TLBack/sendCheck',
            onComplete: (ret) => {
                this.BtnClose()
            }
        });
    }

    BtnClose = () => {
        if (typeof this.props.data.onCancel != "undefined" && typeof this.props.data.onCancel == 'function')
            this.props.data.onCancel();
    }

    render() {
        const { data, isCheck } = this.state;
        // const enums = this.props.data.enums ? this.props.data.enums : this.props.app.enums;
        return <div>
            <div style={{ padding: '10px' }}>
                <table>
                    <tr>
                        <td><Button onClick={() => this.onClickApprove(true)} style={{ marginRight: '8px' }} icon='export'>审批详情</Button></td>
                        <td><ReactToPrint trigger={() => <Button type={'default'} icon={'printer'} >打印</Button>} content={() => this.componentRef} /></td>
                        {/* <td><Button type={'primary'} icon={'check'} onClick={() => this.sureCheck()} >确认</Button>  </td> */}
                        <td><ExportToExcel fileName='回采计划' tableId={'tableId' + this.props.data.id} /></td>
                        {
                            isCheck ? <td><Button type={'primary'} icon={'check'} onClick={() => this.sureCheck()} >确认</Button>  </td> : null
                        }
                    </tr>
                </table>
            </div>
            <FormPage {...this.state.tmpData} />
            <div ref={el => (this.componentRef = el)} style={{ padding: '20px', paddingTop: '20px' }} id={'tableId' + this.props.data.id}>
                <h1 className={styles.showPrintHead}>回采计划</h1>
                {
                    data ? <div style={{ width: '95%' }}>
                        <Descriptions title='' size='middle' bordered>
                            <Descriptions.Item label="尾矿库">{data.TAILING_NAME}</Descriptions.Item>
                            <Descriptions.Item label="项目编号">{data.CODE}</Descriptions.Item>
                            <Descriptions.Item label="工程名称">{data.NAME}</Descriptions.Item>
                            <Descriptions.Item label="制定要求">{data.Nav_ListBackRequire?.map((item, i) => {
                                return (i > 0 ? ',' : '') + item.Nav_Require.NAME
                            })}</Descriptions.Item>
                            <Descriptions.Item label="回采计划">{showFiles(data.Nav_Files, config.picServerHost)}</Descriptions.Item>
                        </Descriptions>
                    </div> : null
                }
                {
                    (data?.Nav_ListDetail && data?.Nav_ListDetail.length > 0) ?
                        <table className={styles.PrintFormLight}>
                            <tbody>
                                <tr>
                                    <td colSpan={4} className={styles.showPrintHead2}>计划明细</td>
                                </tr>
                                <tr className={styles.PrintFormLightTh}>
                                    <td>回踩日期</td>
                                    <td>回踩开始时间</td>
                                    <td>回踩结束时间</td>
                                    <td>值班人</td>
                                </tr>
                                {data?.Nav_ListDetail?.map((item, i) => {
                                    return <tr>
                                        <td>{item.DATE?.split(' ')[0]} </td>
                                        <td>{item.DATESTART?.split(' ')[1]} </td>
                                        <td>{item.DATEEND?.split(' ')[1]} </td>
                                        <td>{item.Nav_ListDetailUser?.map((itemtype, j) => { return (j > 0 ? ' ' : '') + itemtype.Nav_User.NAME })}</td>
                                    </tr>
                                })}
                            </tbody>
                        </table>
                        : null
                }
            </div>
        </div>
    }
}
export default connect(({ login }) => ({ login }))(TL014ShowPrint) 
